heat_template_version: rocky

description: >
  OpenStack containerized Ceilometer Agent Compute service

parameters:
  ContainerCeilometerComputeImage:
    description: image
    type: string
  ContainerCeilometerConfigImage:
    description: The container image to use for the ceilometer config_volume
    type: string
  EndpointMap:
    default: {}
    description: Mapping of service endpoint -> protocol. Typically set
                 via parameter_defaults in the resource registry.
    type: json
  ServiceData:
    default: {}
    description: Dictionary packing service data
    type: json
  ServiceNetMap:
    default: {}
    description: Mapping of service_name -> network name. Typically set
                 via parameter_defaults in the resource registry.  This
                 mapping overrides those in ServiceNetMapDefaults.
    type: json
  DefaultPasswords:
    default: {}
    type: json
  RoleName:
    default: ''
    description: Role name on which the service is applied
    type: string
  RoleParameters:
    default: {}
    description: Parameters specific to the role
    type: json
  MonitoringSubscriptionCeilometerCompute:
    default: 'overcloud-ceilometer-agent-compute'
    type: string
  InstanceDiscoveryMethod:
    default: 'libvirt_metadata'
    description: Method used to discover instances running on compute node
    type: string
    constraints:
    - allowed_values: ['naive', 'libvirt_metadata', 'workload_partitioning']
  RedisPassword:
    description: The password for the redis service account.
    type: string
    hidden: true

resources:

  ContainersCommon:
    type: ../containers-common.yaml

  CeilometerServiceBase:
    type: ./ceilometer-base-container-puppet.yaml
    properties:
      ServiceData: {get_param: ServiceData}
      ServiceNetMap: {get_param: ServiceNetMap}
      DefaultPasswords: {get_param: DefaultPasswords}
      EndpointMap: {get_param: EndpointMap}
      RoleName: {get_param: RoleName}
      RoleParameters: {get_param: RoleParameters}

outputs:
  role_data:
    description: Role data for the Ceilometer Agent Compute role.
    value:
      service_name: ceilometer_agent_compute
      monitoring_subscription: {get_param: MonitoringSubscriptionCeilometerCompute}
      config_settings:
        map_merge:
          - get_attr: [CeilometerServiceBase, role_data, config_settings]
          - ceilometer::agent::compute::instance_discovery_method: {get_param: InstanceDiscoveryMethod}
          - ceilometer_redis_password: {get_param: RedisPassword}
            compute_namespace: true
      service_config_settings:
        get_attr: [CeilometerServiceBase, role_data, service_config_settings]
      # BEGIN DOCKER SETTINGS
      puppet_config:
        config_volume: ceilometer
        puppet_tags: ceilometer_config
        step_config:
          include ::tripleo::profile::base::ceilometer::agent::polling
        config_image: {get_param: ContainerCeilometerConfigImage}
      kolla_config:
        /var/lib/kolla/config_files/ceilometer_agent_compute.json:
          command: /usr/bin/ceilometer-polling --polling-namespaces compute --logfile /var/log/ceilometer/compute.log
          config_files:
            - source: "/var/lib/kolla/config_files/src/*"
              dest: "/"
              merge: true
              preserve_properties: true
      docker_config:
        step_4:
          ceilometer_agent_compute:
            image: {get_param: ContainerCeilometerComputeImage}
            net: host
            privileged: false
            restart: always
            healthcheck: {get_attr: [ContainersCommon, healthcheck_rpc_port]}
            volumes:
              list_concat:
                - {get_attr: [ContainersCommon, volumes]}
                -
                  - /var/lib/kolla/config_files/ceilometer_agent_compute.json:/var/lib/kolla/config_files/config.json:ro
                  - /var/lib/config-data/puppet-generated/ceilometer/:/var/lib/kolla/config_files/src:ro
                  - /var/run/libvirt:/var/run/libvirt:ro
                  - /var/log/containers/ceilometer:/var/log/ceilometer:z
            environment:
              KOLLA_CONFIG_STRATEGY: COPY_ALWAYS
      host_prep_tasks:
        - name: create persistent directories
          file:
            path: "{{ item.path }}"
            state: directory
            setype: "{{ item.setype }}"
          with_items:
            - { 'path': /var/log/containers/ceilometer, 'setype': svirt_sandbox_file_t, 'mode': '0750' }
        - name: enable virt_sandbox_use_netlink for healthcheck
          seboolean:
            name: virt_sandbox_use_netlink
            persistent: yes
            state: yes
      fast_forward_upgrade_tasks:
        - when:
            - step|int == 0
            - release == 'ocata'
          block:
            - name: FFU check if openstack-ceilometer-compute is deployed
              command: systemctl is-enabled openstack-ceilometer-compute
              ignore_errors: True
              register: ceilometer_agent_compute_enabled_result
            - name: Set fact ceilometer_agent_compute_enabled
              set_fact:
                ceilometer_agent_compute_enabled: "{{ ceilometer_agent_compute_enabled_result.rc == 0 }}"
        - name: FFU stop and disable openstack-ceilometer-compute service
          when:
            - step|int == 1
            - release == 'ocata'
            - ceilometer_agent_compute_enabled|bool
          service: name=openstack-ceilometer-compute state=stopped enabled=no
